version: '3.5'

x-enviroment: &laravelEnvironment
  APP_NAME: ${APP_NAME}
  REDIS_HOST: redis
  REDIS_PASSWORD: null
  REDIS_PORT: 6379
  DB_CONNECTION: mysql
  DB_HOST: mysql
  DB_PORT: 3306
  DB_DATABASE: ${MYSQL_DATABASE}
  DB_USERNAME: ${MYSQL_USER}
  DB_PASSWORD: ${MYSQL_PASSWORD}
  QUEUE_CONNECTION: redis
  REDIS_CLIENT: predis

volumes:
  db:

services:
  nginx:
    image: nginx:latest
    container_name: ${APP_NAME}__nginx
    ports:
      - ${BACKEND_EXTERNAL_PORT}:80
    volumes:
      - ./backend-app:/var/www/html
      - ./docker/nginx/default.conf:/etc/nginx/conf.d/default.conf
    depends_on:
      - php
      - mysql

  mysql:
    image: mysql
    container_name: ${APP_NAME}__mysql
    restart: unless-stopped
    tty: true
    ports:
      - ${MYSQL_EXTERNAL_PORT}:3306
    environment:
      MYSQL_DATABASE: ${MYSQL_DATABASE}
      MYSQL_USER: ${MYSQL_USER}
      MYSQL_PASSWORD: ${MYSQL_PASSWORD}
      MYSQL_ROOT_PASSWORD: ${MYSQL_ROOT_PASSWORD}
      SERVICE_TAGS: dev
      SERVICE_NAME: ${APP_NAME}__mysql
    volumes:
      - db:/var/lib/mysql
      - ./docker/mysql/my.cnf:/etc/mysql/conf.d/my.cnf

  php:
    build:
      args: 
        user: ${USER_NAME}
        uid:  ${USER_UID}
      context: ./docker/php
      dockerfile: Dockerfile
    container_name: ${APP_NAME}__php
    volumes:
      - ./backend-app:/var/www/html
      - ./docker/php/php.local.ini:/usr/local/etc/php/conf.d/php.local.ini
    environment: *laravelEnvironment

  php-horizon:
    build:
      args: 
        user: ${USER_NAME}
        uid:  ${USER_UID}
      context: ./docker/php
      dockerfile: Dockerfile
    container_name: ${APP_NAME}__php-horizon
    volumes:
      - ./backend-app:/var/www/html
      - ./docker/php-horizon/supervisord.conf:/etc/supervisord.conf
    entrypoint: ['/usr/bin/supervisord', '-n', '-c',  '/etc/supervisord.conf']
    environment: *laravelEnvironment
    depends_on:
      - redis
      - mysql
  
  redis:
    image: redis
    container_name: ${APP_NAME}__redis
    restart: on-failure
    ports:
      - ${REDIS_EXTERNAL_PORT}:6379

  composer:
    build:
      args: 
        user: ${USER_NAME}
        uid:  ${USER_UID}
      context: ./docker/php
      dockerfile: Dockerfile
    container_name: ${APP_NAME}__composer
    volumes:
      - ./backend-app:/var/www/html
    working_dir: /var/www/html
    entrypoint: ['composer']

  yarn:
    image: node
    container_name: ${APP_NAME}__yarn
    volumes:
      - ./frontend-app:/var/www/html
    working_dir: /var/www/html
    entrypoint: ['yarn']

  artisan:
    build:
      args: 
        user: ${USER_NAME}
        uid:  ${USER_UID}
      context: ./docker/php
      dockerfile: Dockerfile
    container_name: ${APP_NAME}__artisan
    volumes:
      - ./backend-app:/var/www/html
    depends_on:
      - mysql
    working_dir: /var/www/html
    entrypoint: ['php', '/var/www/html/artisan']
    environment: *laravelEnvironment

  phpmyadmin:
    image: phpmyadmin/phpmyadmin
    container_name: ${APP_NAME}__pma
    depends_on:
      - mysql
    environment:
      PMA_HOST: ${APP_NAME}__mysql
      PMA_PORT: 3306
      MYSQL_ROOT_PASSWORD: 'root'
      PMA_USER: 'root'
      PMA_PASSWORD: 'root'
      PMA_ARBITRARY: 1
    restart: always
    ports:
      - ${PHPMYADMIN_EXTERNAL_PORT}:80
